/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1990 MIPS Computer Systems, Inc.            |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 52.227-7013.   |
 * |         MIPS Computer Systems, Inc.                       |
 * |         928 Arques Avenue                                 |
 * |         Sunnyvale, CA 94086                               |
 * |-----------------------------------------------------------|
 */
#ident	"$Header: _mbtowc.c,v 1.1.2.1 92/06/24 14:10:42 marker Exp $"

/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"@(#)libw:port/_mbtowc.c 1.0 AT&T-UP"

#include <ctype.h>
#include <stdlib.h>
#include <sys/types.h>
#define	SS2	0x8e
#define	SS3	0x8f
#define	EUCMASK	0x8080
#define P00	0x0000		/* Code Set 0 */
#define P11	0x8080		/* Code Set 1 */
#define P01	0x0080		/* Code Set 2 */
#define P10	0x8000		/* Code Set 3 */
#define multibyte	(_ctype[520]>1)
#define eucw1	_ctype[514]
#define eucw2   _ctype[515]
#define eucw3   _ctype[516]

int _mbtowc(wchar, s, n)
wchar_t *wchar;
char *s;
size_t n;
{
	register int length;
	register wchar_t intcode;
	register c;
	char *olds = (char *)s;
	wchar_t mask;
	
	if(n <= 0)
		return(-1);
	if(s == (char *)0)
		return 0;
	c = (unsigned char)*s++;
	if(!multibyte || c < 0200) {
		if(wchar)
			*wchar = c;
		return(c ? 1 : 0);
	}
	intcode = 0;
	if (c == SS2) {
		if(!(length = eucw2)) {
			if(wchar)
				*wchar = c;
			return(1);
		}
		mask = P01;
	} else if(c == SS3) {
		if(!(length = eucw3)) {
			if(wchar)
				*wchar = c;
			return(1);
		}
		mask = P10;
	} else {
		if(iscntrl(c)) {
			if(wchar)
				*wchar = c;
			return(1);
		}
		length = eucw1 - 1;
		mask = P11;
		intcode = c & 0177;
	}
	if(length + 1 > n)
		return(-1);
	while(length--) {
		if((c = (unsigned char)*s++) < 0200 || iscntrl(c))
			return(-1);
		intcode = (intcode << 8) | (c & 0177);
	}
	if(wchar)
		*wchar = intcode | mask;
	return((char *)s - olds);
}	
